#!/bin/bash

function die {
  echo "ERROR: $@"
  exit 1
}

function check_file {
  [[ -f "$1" ]] || die "File '$1' not found"
}

if ./1.2.test; then
  echo "Your code passed the correctness tests!"
else
  echo "FAILED: Your code failed the correctness tests."
  exit 1
fi

check_file 1.2.o

for fail in 1.2.fail{1,2}.cc; do
  check_file "$fail"
  if g++ 1.2.o -std=c++11 $fail > /dev/null 2>&1; then
    echo "FAILED: you didn't remove the copy constructor or the assignment operator."
    exit 1
  fi
done
echo "SUCCESS! You solved the exercise."
